//--------------------------------------------------------
//	DemoWindow.h
//	We are not liable for anything involving this software
//	including but not limited to damage or harm to your
//	software, hardware, mind, body or soul.
//		Written by Bill Morris
//		Memetic Corporation
//		bmorris@memetic.com
//		http://www.memetic.com
//	Hacked from HelloWorld
//		Copyright 1995 Be Incorporated, All Rights Reserved.
//--------------------------------------------------------

#ifndef DEMO_VIEW_H
#include "DemoView.h"
#endif

// Replicant Constructor 
DemoView::DemoView(BMessage *data) 
	: BView(data) 
{
} 


// Archive(): store data needed to replicate class 
status_t DemoView::Archive(BMessage *data, bool deep) const 
{ 
        inherited::Archive(data, deep); 
    data->AddString("class", "Demo"); 
    data->AddString("add_on", "application/x-vnd.memetic-DEMO"); 
    return B_OK; 
} 


// Instantiate(): instantiate the DemoView replicant 
DemoView *DemoView::Instantiate(BMessage *data) 
{ 
        if(validate_instantiation(data, "Demo")) 
                return new DemoView(data); 
        
        // In case validation failed... 
        return NULL; 
} 


DemoView::DemoView(BRect rect, char *name)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW|B_PULSE_NEEDED)
{
}


void DemoView::AttachedToWindow()
{
	SetViewColor(0,0,152,0);
	MakeFocus();
	SetFont(be_plain_font);
	SetFontSize(14);

	//	MAGICK!!
	//		this is where it all the setup happens...
	//	instance our list
	BList *foobaz;
	//	instance our filter (maybe instance isn't the right word
	//	but you get the picture
	lmf = new DemoMessageFilter(B_ANY_DELIVERY,B_ANY_SOURCE);
	//	BHandler has the function AddFilter so...
	//	since BView is derived from BHandler it inherits
	//	AddFilter so we will toss it our MessageFilter
	inherited::AddFilter(lmf);
	//	this is the part where i couldn't belive the code
	//	couldn't possibly be working so I check if the
	//	MessageFilter was installed
	foobaz = inherited::FilterList();
	//	I tried checking before I wrote the message filter
	//	to see if there were any filters installed...
	//	It crashed so I guessed there were not any.
	//	At this point I realized the semantics of
	//	BMessageFilter actually meant filters are more
	//	like nets then something to keep your water clean
	//	so adding a filter means it gets all the messages
	//	not that your handler gets more because you replaced
	//	the old filter with a new one.
	if (foobaz == NULL) printf("Filter Pointer NULL!!");
	//	It's BList! It has items... it will count them for you.
	else printf("Filter Count %d\n",foobaz->CountItems());

}


void DemoView::AboutRequested() 
{ 
    BAlert *alert; 
    alert = new BAlert("", 
                "Demo\nThis is a sample Replicant with MouseUp!!", 
                "OK"); 
    alert->Go(); 
}

void DemoView::MouseDown(BPoint point)
{
	//	MAGICK!!
	//		not really because this one normally works...
	MakeFocus();

	BPoint	temp;
	temp = point;
	printf("MouseDown");
	temp.PrintToStream();
}

void DemoView::MouseUp(BPoint point)
{
	//	MAGICK!!
	//		now that this works I am a happy camper hopefully
	//		you are too...
	BPoint	temp;
	temp = point;
	printf("MouseUp");
	temp.PrintToStream();
}

void DemoView::KeyUp(const char *, int32)
{
	printf("KeyUp\n");
}

void DemoView::KeyDown(const char *, int32)
{
	printf("KeyDown\n");
}

void DemoView::MessageReceived(BMessage *a_msg) 
{ 
	a_msg->PrintToStream();

    switch(a_msg->what) { 
        case B_ABOUT_REQUESTED: 
            AboutRequested(); 
            break; 
        
        default: 
            inherited::MessageReceived(a_msg); 
            break; 
    } 
}

